﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

namespace Combo1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            /* UNCOMMENT FOR COMBO2
            comboBox1.DropDownStyle = ComboBoxStyle.DropDownList;
            comboBox1.DrawMode = DrawMode.OwnerDrawFixed;
            */
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DriveInfo[] Drives = DriveInfo.GetDrives();
            foreach (DriveInfo Drive in Drives)
            {
                comboBox1.Items.Add(Drive);
            }
            comboBox1.SelectedIndex = 0;
        }

 //USED IN COMBO2 - UNCOMMENT LINES IN CONSTRUCTOR TO ENABLE THE SECOND VERSION
        private void comboBox1_DrawItem(object sender, DrawItemEventArgs e)
        {
            if (e.Index == -1) return;
            DriveInfo drive = (DriveInfo)comboBox1.Items[e.Index];
            Icon icon;
            switch (drive.DriveType)
            {
                case (DriveType.Fixed):
                    icon = ShellIcons.HardDisk;
                    break;
                case (DriveType.CDRom):
                    icon = ShellIcons.CDROM;
                    break;
                case (DriveType.Network):
                    icon = ShellIcons.NetDisk;
                    break;
                case (DriveType.Removable):
                    icon = ShellIcons.FloppyDisk;
                    break;
                default:
                    icon = ShellIcons.UnknownDisk;
                    break;
            }
            Rectangle iconbox = new Rectangle(
                            e.Bounds.X, e.Bounds.Y,
                              e.Bounds.Height, e.Bounds.Height);
            e.DrawBackground();
            e.Graphics.DrawIcon(icon, iconbox);
            icon.Dispose();
            string text = drive.Name;
            if (drive.IsReady)
            {
                if (drive.VolumeLabel != "")
                {
                    text = text + " (" + drive.VolumeLabel + ")";
                }
            }
            e.Graphics.DrawString(text,
                     e.Font,
                       new SolidBrush(e.ForeColor),
                       e.Bounds.X + iconbox.Width + 1,
                       e.Bounds.Y);
            if (e.State == DrawItemState.Focus)
            {
                e.DrawFocusRectangle();
            }
        }
 
    }
}
